#include <mwm5.h>

#include <Arduino.h>
#include <M5Stack.h>

// ①TWETerm_M5_Consoleオブジェクトの作成
static TWETerm_M5_Console myscreen(64, 40, { 0, 0, 320, 240}, M5);

void setup() {
  // M5Stackの初期化
  M5.begin(true, false, true, false); 

  // ターミナルの初期化
  // ②フォントの作成
  // MP+フォント12ピクセルの作成
  // 通常フォントをフォント番号10番に。行間・字間は0。
  TWEFONT::createFontMP12(10, 0, 0);
  myscreen.set_font(10);

  // ③背景色と前景色の設定
  myscreen.set_color(
    color565(90, 0, 50),  // 背景色
    color565(255, 255, 255) //前景色
  );

  // ④カーソルのセット
  // 0 = なし、1=カーソル、2=点滅カーソル
  myscreen.set_cursor(2);

  // ⑤クリアとリフレッシュ
  myscreen.clear_screen();
  myscreen.force_refresh();
}

void loop() {
  if (M5.BtnA.wasPressed()) {
    // ⑦基本的な出力
    myscreen << "こんにちは\n";    
  }

  if (M5.BtnB.wasPressed()) {
    // ⑧書式出力
    myscreen << printfmt("計算した値=%f\n", 100 * 3.3);    
  }

  if (M5.BtnC.wasPressed()) {
    // ⑨文字属性付き出力
    // 背景黒、文字色シアン
    myscreen << TermAttr(TERM_COLOR_BG_BLACK | TERM_COLOR_FG_CYAN);
    myscreen << "色が付いた文字\n";

    myscreen << TermAttr(TERM_ATTR_OFF);
  }
  
  // ⑩ターミナルのリフレッシュ
  myscreen.refresh();

  m5.update();
 
}
