# ①モジュールのインポート
from datetime import datetime
from wsgiref.simple_server import make_server

# Jinja2
from jinja2 import Template, Environment, FileSystemLoader

# ②受信処理
def process(env, response):
  # （1）ヘッダを返す
  headers = [
    ('Content-Type', 'text/html; charset=utf-8')
  ]
  response('200 OK', headers)
  # （2）コンテンツを返す
  # Jinja2のテンプレートを読み込む
  env = Environment(loader=FileSystemLoader(''))
  template = env.get_template('index.tpl')

  # 値を差し込んでHTMLにする
  dt = datetime.now().strftime("%Y年%m月%d日")
  html = template.render({'today' : dt})
  return [html.encode('utf-8')]

# ③サーバの立ち上げ
with make_server('', 80, process) as httpd:
  print("started")
  httpd.serve_forever()
