import paho.mqtt.client
import json

# ①接続情報
endpoint = 'XXXXXXXXXX-ats.iot.ap-northeast-1.amazonaws.com'
port = 8883
topic = 'pal/amb0001'
rootca = 'AmazonRootCA1.pem'
cert = 'XXXXXXXXXX-certificate.pem.crt'
privatekey = 'XXXXXXXXXX-private.pem.key'

# コールバック関数
connected = False
def onConnect(client, userdata, flag, rc):
  global connected
  if rc == 0:
    connected = True
  else:
    print('接続失敗')
    exit
  
# 以下プログラム
# ②クライアントオブジェクトを作る
client = paho.mqtt.client.Client()

# ③証明書を設定する
client.tls_set(
  ca_certs=rootca, 
  certfile=cert, 
  keyfile=privatekey)

# ④コールバック関数を設定する
client.on_connect = onConnect

# ⑤接続する
client.connect(endpoint, port=port)

# ⑥処理ループ開始
client.loop_start()

# ⑦接続完了まで待つ
while not connected:
  pass

# ⑧送信
data = {
  'temperature' : 20.00,
  'humidity': 70.00,
  'illuminance': 100
}

info = client.publish(topic, json.dumps(data))
info.wait_for_publish()

# ⑨終了と切断
client.loop_stop()
client.disconnect()
