# TWELITE関連
import sys
sys.path.append('./MNLib/')
from apppal import AppPAL

# MONOSTICKのポート
comport = '/dev/ttyUSB0'

#### ---------------- ここからリスト 6 1と同じ
# MQTT関連
import paho.mqtt.client
import json

# MQTT接続情報
endpoint = 'XXXXXXXXXX-ats.iot.ap-northeast-1.amazonaws.com'
port = 8883
topic = 'pal/amb0001'
rootca = 'AmazonRootCA1.pem'
cert = 'XXXXXXXXXX-certificate.pem.crt'
privatekey = 'XXXXXXXXXX-private.pem.key'

# コールバック関数
connected = False
def onConnect(client, userdata, flag, rc):
  global connected
  if rc == 0:
    connected = True
  else:
    print('接続失敗')
    exit
  
# 以下プログラム
# ②クライアントオブジェクトを作る
client = paho.mqtt.client.Client()

# ③証明書を設定する
client.tls_set(
  ca_certs=rootca, 
  certfile=cert, 
  keyfile=privatekey)

# ④コールバック関数を設定する
client.on_connect = onConnect

# ⑤接続する
client.connect(endpoint, port=port)

# ⑥処理ループ開始
client.loop_start()

# ⑦接続完了まで待つ
while not connected:
  pass

#### ---------------- ここまでリスト 6 1と同じ
# MONOSTICKのデータに基づく送信
####

# PALオブジェクトの生成
PAL = AppPAL(port = comport)

# データの取得
while True:
  # データが届いているか
  if PAL.ReadSensorData():
    # 届いているなら、値を送信
    data = PAL.GetDataDict()
    if data['PALID'] == 2:
      topic = "pal/amb{0:04d}".format(data['LogicalID'])
      senddata = {
          'temperature' : data.get('Temperature'),
          'humidity': data.get('Humidity'),
          'illuminance': data.get('Illuminance')
      }
      print(topic, senddata)
      info = client.publish(topic, json.dumps(senddata))
      info.wait_for_publish()
del PAL

#### ---------------- ここからリスト 6 1と同じ

# ⑨終了と切断
client.loop_stop()
client.disconnect()
